"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _SetCache_js_1 = require("./_SetCache.js");
var _arrayIncludes_js_1 = require("./_arrayIncludes.js");
var _arrayIncludesWith_js_1 = require("./_arrayIncludesWith.js");
var _arrayMap_js_1 = require("./_arrayMap.js");
var _baseUnary_js_1 = require("./_baseUnary.js");
var _cacheHas_js_1 = require("./_cacheHas.js");
var LARGE_ARRAY_SIZE = 200;
function baseDifference(array, values, iteratee, comparator) {
    var index = -1, includes = _arrayIncludes_js_1.default, isCommon = true, length = array.length, result = [], valuesLength = values.length;
    if (!length) {
        return result;
    }
    if (iteratee) {
        values = _arrayMap_js_1.default(values, _baseUnary_js_1.default(iteratee));
    }
    if (comparator) {
        includes = _arrayIncludesWith_js_1.default;
        isCommon = false;
    }
    else if (values.length >= LARGE_ARRAY_SIZE) {
        includes = _cacheHas_js_1.default;
        isCommon = false;
        values = new _SetCache_js_1.default(values);
    }
    outer: while (++index < length) {
        var value = array[index], computed = iteratee == null ? value : iteratee(value);
        value = (comparator || value !== 0) ? value : 0;
        if (isCommon && computed === computed) {
            var valuesIndex = valuesLength;
            while (valuesIndex--) {
                if (values[valuesIndex] === computed) {
                    continue outer;
                }
            }
            result.push(value);
        }
        else if (!includes(values, computed, comparator)) {
            result.push(value);
        }
    }
    return result;
}
exports.default = baseDifference;
