"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _arrayPush_js_1 = require("./_arrayPush.js");
var _isFlattenable_js_1 = require("./_isFlattenable.js");
function baseFlatten(array, depth, predicate, isStrict, result) {
    var index = -1, length = array.length;
    predicate || (predicate = _isFlattenable_js_1.default);
    result || (result = []);
    while (++index < length) {
        var value = array[index];
        if (depth > 0 && predicate(value)) {
            if (depth > 1) {
                baseFlatten(value, depth - 1, predicate, isStrict, result);
            }
            else {
                _arrayPush_js_1.default(result, value);
            }
        }
        else if (!isStrict) {
            result[result.length] = value;
        }
    }
    return result;
}
exports.default = baseFlatten;
