"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _SetCache_js_1 = require("./_SetCache.js");
var _arrayIncludes_js_1 = require("./_arrayIncludes.js");
var _arrayIncludesWith_js_1 = require("./_arrayIncludesWith.js");
var _arrayMap_js_1 = require("./_arrayMap.js");
var _baseUnary_js_1 = require("./_baseUnary.js");
var _cacheHas_js_1 = require("./_cacheHas.js");
var nativeMin = Math.min;
function baseIntersection(arrays, iteratee, comparator) {
    var includes = comparator ? _arrayIncludesWith_js_1.default : _arrayIncludes_js_1.default, length = arrays[0].length, othLength = arrays.length, othIndex = othLength, caches = Array(othLength), maxLength = Infinity, result = [];
    while (othIndex--) {
        var array = arrays[othIndex];
        if (othIndex && iteratee) {
            array = _arrayMap_js_1.default(array, _baseUnary_js_1.default(iteratee));
        }
        maxLength = nativeMin(array.length, maxLength);
        caches[othIndex] = !comparator && (iteratee || (length >= 120 && array.length >= 120))
            ? new _SetCache_js_1.default(othIndex && array)
            : undefined;
    }
    array = arrays[0];
    var index = -1, seen = caches[0];
    outer: while (++index < length && result.length < maxLength) {
        var value = array[index], computed = iteratee ? iteratee(value) : value;
        value = (comparator || value !== 0) ? value : 0;
        if (!(seen
            ? _cacheHas_js_1.default(seen, computed)
            : includes(result, computed, comparator))) {
            othIndex = othLength;
            while (--othIndex) {
                var cache = caches[othIndex];
                if (!(cache
                    ? _cacheHas_js_1.default(cache, computed)
                    : includes(arrays[othIndex], computed, comparator))) {
                    continue outer;
                }
            }
            if (seen) {
                seen.push(computed);
            }
            result.push(value);
        }
    }
    return result;
}
exports.default = baseIntersection;
