"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _Stack_js_1 = require("./_Stack.js");
var _equalArrays_js_1 = require("./_equalArrays.js");
var _equalByTag_js_1 = require("./_equalByTag.js");
var _equalObjects_js_1 = require("./_equalObjects.js");
var _getTag_js_1 = require("./_getTag.js");
var isArray_js_1 = require("./isArray.js");
var isBuffer_js_1 = require("./isBuffer.js");
var isTypedArray_js_1 = require("./isTypedArray.js");
var COMPARE_PARTIAL_FLAG = 1;
var argsTag = '[object Arguments]', arrayTag = '[object Array]', objectTag = '[object Object]';
var objectProto = Object.prototype;
var hasOwnProperty = objectProto.hasOwnProperty;
function baseIsEqualDeep(object, other, bitmask, customizer, equalFunc, stack) {
    var objIsArr = isArray_js_1.default(object), othIsArr = isArray_js_1.default(other), objTag = objIsArr ? arrayTag : _getTag_js_1.default(object), othTag = othIsArr ? arrayTag : _getTag_js_1.default(other);
    objTag = objTag == argsTag ? objectTag : objTag;
    othTag = othTag == argsTag ? objectTag : othTag;
    var objIsObj = objTag == objectTag, othIsObj = othTag == objectTag, isSameTag = objTag == othTag;
    if (isSameTag && isBuffer_js_1.default(object)) {
        if (!isBuffer_js_1.default(other)) {
            return false;
        }
        objIsArr = true;
        objIsObj = false;
    }
    if (isSameTag && !objIsObj) {
        stack || (stack = new _Stack_js_1.default);
        return (objIsArr || isTypedArray_js_1.default(object))
            ? _equalArrays_js_1.default(object, other, bitmask, customizer, equalFunc, stack)
            : _equalByTag_js_1.default(object, other, objTag, bitmask, customizer, equalFunc, stack);
    }
    if (!(bitmask & COMPARE_PARTIAL_FLAG)) {
        var objIsWrapped = objIsObj && hasOwnProperty.call(object, '__wrapped__'), othIsWrapped = othIsObj && hasOwnProperty.call(other, '__wrapped__');
        if (objIsWrapped || othIsWrapped) {
            var objUnwrapped = objIsWrapped ? object.value() : object, othUnwrapped = othIsWrapped ? other.value() : other;
            stack || (stack = new _Stack_js_1.default);
            return equalFunc(objUnwrapped, othUnwrapped, bitmask, customizer, stack);
        }
    }
    if (!isSameTag) {
        return false;
    }
    stack || (stack = new _Stack_js_1.default);
    return _equalObjects_js_1.default(object, other, bitmask, customizer, equalFunc, stack);
}
exports.default = baseIsEqualDeep;
