"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var isFunction_js_1 = require("./isFunction.js");
var _isMasked_js_1 = require("./_isMasked.js");
var isObject_js_1 = require("./isObject.js");
var _toSource_js_1 = require("./_toSource.js");
var reRegExpChar = /[\\^$.*+?()[\]{}|]/g;
var reIsHostCtor = /^\[object .+?Constructor\]$/;
var funcProto = Function.prototype, objectProto = Object.prototype;
var funcToString = funcProto.toString;
var hasOwnProperty = objectProto.hasOwnProperty;
var reIsNative = RegExp('^' +
    funcToString.call(hasOwnProperty).replace(reRegExpChar, '\\$&')
        .replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, '$1.*?') + '$');
function baseIsNative(value) {
    if (!isObject_js_1.default(value) || _isMasked_js_1.default(value)) {
        return false;
    }
    var pattern = isFunction_js_1.default(value) ? reIsNative : reIsHostCtor;
    return pattern.test(_toSource_js_1.default(value));
}
exports.default = baseIsNative;
