"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _baseIsEqual_js_1 = require("./_baseIsEqual.js");
var get_js_1 = require("./get.js");
var hasIn_js_1 = require("./hasIn.js");
var _isKey_js_1 = require("./_isKey.js");
var _isStrictComparable_js_1 = require("./_isStrictComparable.js");
var _matchesStrictComparable_js_1 = require("./_matchesStrictComparable.js");
var _toKey_js_1 = require("./_toKey.js");
var COMPARE_PARTIAL_FLAG = 1, COMPARE_UNORDERED_FLAG = 2;
function baseMatchesProperty(path, srcValue) {
    if (_isKey_js_1.default(path) && _isStrictComparable_js_1.default(srcValue)) {
        return _matchesStrictComparable_js_1.default(_toKey_js_1.default(path), srcValue);
    }
    return function (object) {
        var objValue = get_js_1.default(object, path);
        return (objValue === undefined && objValue === srcValue)
            ? hasIn_js_1.default(object, path)
            : _baseIsEqual_js_1.default(srcValue, objValue, COMPARE_PARTIAL_FLAG | COMPARE_UNORDERED_FLAG);
    };
}
exports.default = baseMatchesProperty;
