"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _assignMergeValue_js_1 = require("./_assignMergeValue.js");
var _cloneBuffer_js_1 = require("./_cloneBuffer.js");
var _cloneTypedArray_js_1 = require("./_cloneTypedArray.js");
var _copyArray_js_1 = require("./_copyArray.js");
var _initCloneObject_js_1 = require("./_initCloneObject.js");
var isArguments_js_1 = require("./isArguments.js");
var isArray_js_1 = require("./isArray.js");
var isArrayLikeObject_js_1 = require("./isArrayLikeObject.js");
var isBuffer_js_1 = require("./isBuffer.js");
var isFunction_js_1 = require("./isFunction.js");
var isObject_js_1 = require("./isObject.js");
var isPlainObject_js_1 = require("./isPlainObject.js");
var isTypedArray_js_1 = require("./isTypedArray.js");
var toPlainObject_js_1 = require("./toPlainObject.js");
function baseMergeDeep(object, source, key, srcIndex, mergeFunc, customizer, stack) {
    var objValue = object[key], srcValue = source[key], stacked = stack.get(srcValue);
    if (stacked) {
        _assignMergeValue_js_1.default(object, key, stacked);
        return;
    }
    var newValue = customizer
        ? customizer(objValue, srcValue, (key + ''), object, source, stack)
        : undefined;
    var isCommon = newValue === undefined;
    if (isCommon) {
        var isArr = isArray_js_1.default(srcValue), isBuff = !isArr && isBuffer_js_1.default(srcValue), isTyped = !isArr && !isBuff && isTypedArray_js_1.default(srcValue);
        newValue = srcValue;
        if (isArr || isBuff || isTyped) {
            if (isArray_js_1.default(objValue)) {
                newValue = objValue;
            }
            else if (isArrayLikeObject_js_1.default(objValue)) {
                newValue = _copyArray_js_1.default(objValue);
            }
            else if (isBuff) {
                isCommon = false;
                newValue = _cloneBuffer_js_1.default(srcValue, true);
            }
            else if (isTyped) {
                isCommon = false;
                newValue = _cloneTypedArray_js_1.default(srcValue, true);
            }
            else {
                newValue = [];
            }
        }
        else if (isPlainObject_js_1.default(srcValue) || isArguments_js_1.default(srcValue)) {
            newValue = objValue;
            if (isArguments_js_1.default(objValue)) {
                newValue = toPlainObject_js_1.default(objValue);
            }
            else if (!isObject_js_1.default(objValue) || (srcIndex && isFunction_js_1.default(objValue))) {
                newValue = _initCloneObject_js_1.default(srcValue);
            }
        }
        else {
            isCommon = false;
        }
    }
    if (isCommon) {
        stack.set(srcValue, newValue);
        mergeFunc(newValue, srcValue, srcIndex, customizer, stack);
        stack['delete'](srcValue);
    }
    _assignMergeValue_js_1.default(object, key, newValue);
}
exports.default = baseMergeDeep;
