"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _arrayMap_js_1 = require("./_arrayMap.js");
var _baseIteratee_js_1 = require("./_baseIteratee.js");
var _baseMap_js_1 = require("./_baseMap.js");
var _baseSortBy_js_1 = require("./_baseSortBy.js");
var _baseUnary_js_1 = require("./_baseUnary.js");
var _compareMultiple_js_1 = require("./_compareMultiple.js");
var identity_js_1 = require("./identity.js");
function baseOrderBy(collection, iteratees, orders) {
    var index = -1;
    iteratees = _arrayMap_js_1.default(iteratees.length ? iteratees : [identity_js_1.default], _baseUnary_js_1.default(_baseIteratee_js_1.default));
    var result = _baseMap_js_1.default(collection, function (value, key, collection) {
        var criteria = _arrayMap_js_1.default(iteratees, function (iteratee) {
            return iteratee(value);
        });
        return { 'criteria': criteria, 'index': ++index, 'value': value };
    });
    return _baseSortBy_js_1.default(result, function (object, other) {
        return _compareMultiple_js_1.default(object, other, orders);
    });
}
exports.default = baseOrderBy;
