"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _arrayMap_js_1 = require("./_arrayMap.js");
var _baseIndexOf_js_1 = require("./_baseIndexOf.js");
var _baseIndexOfWith_js_1 = require("./_baseIndexOfWith.js");
var _baseUnary_js_1 = require("./_baseUnary.js");
var _copyArray_js_1 = require("./_copyArray.js");
var arrayProto = Array.prototype;
var splice = arrayProto.splice;
function basePullAll(array, values, iteratee, comparator) {
    var indexOf = comparator ? _baseIndexOfWith_js_1.default : _baseIndexOf_js_1.default, index = -1, length = values.length, seen = array;
    if (array === values) {
        values = _copyArray_js_1.default(values);
    }
    if (iteratee) {
        seen = _arrayMap_js_1.default(array, _baseUnary_js_1.default(iteratee));
    }
    while (++index < length) {
        var fromIndex = 0, value = values[index], computed = iteratee ? iteratee(value) : value;
        while ((fromIndex = indexOf(seen, computed, fromIndex, comparator)) > -1) {
            if (seen !== array) {
                splice.call(seen, fromIndex, 1);
            }
            splice.call(array, fromIndex, 1);
        }
    }
    return array;
}
exports.default = basePullAll;
