"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _assignValue_js_1 = require("./_assignValue.js");
var _castPath_js_1 = require("./_castPath.js");
var _isIndex_js_1 = require("./_isIndex.js");
var isObject_js_1 = require("./isObject.js");
var _toKey_js_1 = require("./_toKey.js");
function baseSet(object, path, value, customizer) {
    if (!isObject_js_1.default(object)) {
        return object;
    }
    path = _castPath_js_1.default(path, object);
    var index = -1, length = path.length, lastIndex = length - 1, nested = object;
    while (nested != null && ++index < length) {
        var key = _toKey_js_1.default(path[index]), newValue = value;
        if (index != lastIndex) {
            var objValue = nested[key];
            newValue = customizer ? customizer(objValue, key, nested) : undefined;
            if (newValue === undefined) {
                newValue = isObject_js_1.default(objValue)
                    ? objValue
                    : (_isIndex_js_1.default(path[index + 1]) ? [] : {});
            }
        }
        _assignValue_js_1.default(nested, key, newValue);
        nested = nested[key];
    }
    return object;
}
exports.default = baseSet;
