"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _baseSortedIndexBy_js_1 = require("./_baseSortedIndexBy.js");
var identity_js_1 = require("./identity.js");
var isSymbol_js_1 = require("./isSymbol.js");
var MAX_ARRAY_LENGTH = 4294967295, HALF_MAX_ARRAY_LENGTH = MAX_ARRAY_LENGTH >>> 1;
function baseSortedIndex(array, value, retHighest) {
    var low = 0, high = array == null ? low : array.length;
    if (typeof value == 'number' && value === value && high <= HALF_MAX_ARRAY_LENGTH) {
        while (low < high) {
            var mid = (low + high) >>> 1, computed = array[mid];
            if (computed !== null && !isSymbol_js_1.default(computed) &&
                (retHighest ? (computed <= value) : (computed < value))) {
                low = mid + 1;
            }
            else {
                high = mid;
            }
        }
        return high;
    }
    return _baseSortedIndexBy_js_1.default(array, value, identity_js_1.default, retHighest);
}
exports.default = baseSortedIndex;
