"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var isSymbol_js_1 = require("./isSymbol.js");
var MAX_ARRAY_LENGTH = 4294967295, MAX_ARRAY_INDEX = MAX_ARRAY_LENGTH - 1;
var nativeFloor = Math.floor, nativeMin = Math.min;
function baseSortedIndexBy(array, value, iteratee, retHighest) {
    value = iteratee(value);
    var low = 0, high = array == null ? 0 : array.length, valIsNaN = value !== value, valIsNull = value === null, valIsSymbol = isSymbol_js_1.default(value), valIsUndefined = value === undefined;
    while (low < high) {
        var mid = nativeFloor((low + high) / 2), computed = iteratee(array[mid]), othIsDefined = computed !== undefined, othIsNull = computed === null, othIsReflexive = computed === computed, othIsSymbol = isSymbol_js_1.default(computed);
        if (valIsNaN) {
            var setLow = retHighest || othIsReflexive;
        }
        else if (valIsUndefined) {
            setLow = othIsReflexive && (retHighest || othIsDefined);
        }
        else if (valIsNull) {
            setLow = othIsReflexive && othIsDefined && (retHighest || !othIsNull);
        }
        else if (valIsSymbol) {
            setLow = othIsReflexive && othIsDefined && !othIsNull && (retHighest || !othIsSymbol);
        }
        else if (othIsNull || othIsSymbol) {
            setLow = false;
        }
        else {
            setLow = retHighest ? (computed <= value) : (computed < value);
        }
        if (setLow) {
            low = mid + 1;
        }
        else {
            high = mid;
        }
    }
    return nativeMin(high, MAX_ARRAY_INDEX);
}
exports.default = baseSortedIndexBy;
