"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _Symbol_js_1 = require("./_Symbol.js");
var _arrayMap_js_1 = require("./_arrayMap.js");
var isArray_js_1 = require("./isArray.js");
var isSymbol_js_1 = require("./isSymbol.js");
var INFINITY = 1 / 0;
var symbolProto = _Symbol_js_1.default ? _Symbol_js_1.default.prototype : undefined, symbolToString = symbolProto ? symbolProto.toString : undefined;
function baseToString(value) {
    if (typeof value == 'string') {
        return value;
    }
    if (isArray_js_1.default(value)) {
        return _arrayMap_js_1.default(value, baseToString) + '';
    }
    if (isSymbol_js_1.default(value)) {
        return symbolToString ? symbolToString.call(value) : '';
    }
    var result = (value + '');
    return (result == '0' && (1 / value) == -INFINITY) ? '-0' : result;
}
exports.default = baseToString;
