"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _SetCache_js_1 = require("./_SetCache.js");
var _arrayIncludes_js_1 = require("./_arrayIncludes.js");
var _arrayIncludesWith_js_1 = require("./_arrayIncludesWith.js");
var _cacheHas_js_1 = require("./_cacheHas.js");
var _createSet_js_1 = require("./_createSet.js");
var _setToArray_js_1 = require("./_setToArray.js");
var LARGE_ARRAY_SIZE = 200;
function baseUniq(array, iteratee, comparator) {
    var index = -1, includes = _arrayIncludes_js_1.default, length = array.length, isCommon = true, result = [], seen = result;
    if (comparator) {
        isCommon = false;
        includes = _arrayIncludesWith_js_1.default;
    }
    else if (length >= LARGE_ARRAY_SIZE) {
        var set = iteratee ? null : _createSet_js_1.default(array);
        if (set) {
            return _setToArray_js_1.default(set);
        }
        isCommon = false;
        includes = _cacheHas_js_1.default;
        seen = new _SetCache_js_1.default;
    }
    else {
        seen = iteratee ? [] : result;
    }
    outer: while (++index < length) {
        var value = array[index], computed = iteratee ? iteratee(value) : value;
        value = (comparator || value !== 0) ? value : 0;
        if (isCommon && computed === computed) {
            var seenIndex = seen.length;
            while (seenIndex--) {
                if (seen[seenIndex] === computed) {
                    continue outer;
                }
            }
            if (iteratee) {
                seen.push(computed);
            }
            result.push(value);
        }
        else if (!includes(seen, computed, comparator)) {
            if (seen !== result) {
                seen.push(computed);
            }
            result.push(value);
        }
    }
    return result;
}
exports.default = baseUniq;
