"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _arrayAggregator_js_1 = require("./_arrayAggregator.js");
var _baseAggregator_js_1 = require("./_baseAggregator.js");
var _baseIteratee_js_1 = require("./_baseIteratee.js");
var isArray_js_1 = require("./isArray.js");
function createAggregator(setter, initializer) {
    return function (collection, iteratee) {
        var func = isArray_js_1.default(collection) ? _arrayAggregator_js_1.default : _baseAggregator_js_1.default, accumulator = initializer ? initializer() : {};
        return func(collection, setter, _baseIteratee_js_1.default(iteratee, 2), accumulator);
    };
}
exports.default = createAggregator;
