"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _castSlice_js_1 = require("./_castSlice.js");
var _hasUnicode_js_1 = require("./_hasUnicode.js");
var _stringToArray_js_1 = require("./_stringToArray.js");
var toString_js_1 = require("./toString.js");
function createCaseFirst(methodName) {
    return function (string) {
        string = toString_js_1.default(string);
        var strSymbols = _hasUnicode_js_1.default(string)
            ? _stringToArray_js_1.default(string)
            : undefined;
        var chr = strSymbols
            ? strSymbols[0]
            : string.charAt(0);
        var trailing = strSymbols
            ? _castSlice_js_1.default(strSymbols, 1).join('')
            : string.slice(1);
        return chr[methodName]() + trailing;
    };
}
exports.default = createCaseFirst;
