"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _apply_js_1 = require("./_apply.js");
var _createCtor_js_1 = require("./_createCtor.js");
var _createHybrid_js_1 = require("./_createHybrid.js");
var _createRecurry_js_1 = require("./_createRecurry.js");
var _getHolder_js_1 = require("./_getHolder.js");
var _replaceHolders_js_1 = require("./_replaceHolders.js");
var _root_js_1 = require("./_root.js");
function createCurry(func, bitmask, arity) {
    var Ctor = _createCtor_js_1.default(func);
    function wrapper() {
        var length = arguments.length, args = Array(length), index = length, placeholder = _getHolder_js_1.default(wrapper);
        while (index--) {
            args[index] = arguments[index];
        }
        var holders = (length < 3 && args[0] !== placeholder && args[length - 1] !== placeholder)
            ? []
            : _replaceHolders_js_1.default(args, placeholder);
        length -= holders.length;
        if (length < arity) {
            return _createRecurry_js_1.default(func, bitmask, _createHybrid_js_1.default, wrapper.placeholder, undefined, args, holders, undefined, undefined, arity - length);
        }
        var fn = (this && this !== _root_js_1.default && this instanceof wrapper) ? Ctor : func;
        return _apply_js_1.default(fn, this, args);
    }
    return wrapper;
}
exports.default = createCurry;
