"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _baseIteratee_js_1 = require("./_baseIteratee.js");
var isArrayLike_js_1 = require("./isArrayLike.js");
var keys_js_1 = require("./keys.js");
function createFind(findIndexFunc) {
    return function (collection, predicate, fromIndex) {
        var iterable = Object(collection);
        if (!isArrayLike_js_1.default(collection)) {
            var iteratee = _baseIteratee_js_1.default(predicate, 3);
            collection = keys_js_1.default(collection);
            predicate = function (key) { return iteratee(iterable[key], key, iterable); };
        }
        var index = findIndexFunc(collection, predicate, fromIndex);
        return index > -1 ? iterable[iteratee ? collection[index] : index] : undefined;
    };
}
exports.default = createFind;
