"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _LodashWrapper_js_1 = require("./_LodashWrapper.js");
var _flatRest_js_1 = require("./_flatRest.js");
var _getData_js_1 = require("./_getData.js");
var _getFuncName_js_1 = require("./_getFuncName.js");
var isArray_js_1 = require("./isArray.js");
var _isLaziable_js_1 = require("./_isLaziable.js");
var FUNC_ERROR_TEXT = 'Expected a function';
var WRAP_CURRY_FLAG = 8, WRAP_PARTIAL_FLAG = 32, WRAP_ARY_FLAG = 128, WRAP_REARG_FLAG = 256;
function createFlow(fromRight) {
    return _flatRest_js_1.default(function (funcs) {
        var length = funcs.length, index = length, prereq = _LodashWrapper_js_1.default.prototype.thru;
        if (fromRight) {
            funcs.reverse();
        }
        while (index--) {
            var func = funcs[index];
            if (typeof func != 'function') {
                throw new TypeError(FUNC_ERROR_TEXT);
            }
            if (prereq && !wrapper && _getFuncName_js_1.default(func) == 'wrapper') {
                var wrapper = new _LodashWrapper_js_1.default([], true);
            }
        }
        index = wrapper ? index : length;
        while (++index < length) {
            func = funcs[index];
            var funcName = _getFuncName_js_1.default(func), data = funcName == 'wrapper' ? _getData_js_1.default(func) : undefined;
            if (data && _isLaziable_js_1.default(data[0]) &&
                data[1] == (WRAP_ARY_FLAG | WRAP_CURRY_FLAG | WRAP_PARTIAL_FLAG | WRAP_REARG_FLAG) &&
                !data[4].length && data[9] == 1) {
                wrapper = wrapper[_getFuncName_js_1.default(data[0])].apply(wrapper, data[3]);
            }
            else {
                wrapper = (func.length == 1 && _isLaziable_js_1.default(func))
                    ? wrapper[funcName]()
                    : wrapper.thru(func);
            }
        }
        return function () {
            var args = arguments, value = args[0];
            if (wrapper && args.length == 1 && isArray_js_1.default(value)) {
                return wrapper.plant(value).value();
            }
            var index = 0, result = length ? funcs[index].apply(this, args) : value;
            while (++index < length) {
                result = funcs[index].call(this, result);
            }
            return result;
        };
    });
}
exports.default = createFlow;
