"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _baseToNumber_js_1 = require("./_baseToNumber.js");
var _baseToString_js_1 = require("./_baseToString.js");
function createMathOperation(operator, defaultValue) {
    return function (value, other) {
        var result;
        if (value === undefined && other === undefined) {
            return defaultValue;
        }
        if (value !== undefined) {
            result = value;
        }
        if (other !== undefined) {
            if (result === undefined) {
                return other;
            }
            if (typeof value == 'string' || typeof other == 'string') {
                value = _baseToString_js_1.default(value);
                other = _baseToString_js_1.default(other);
            }
            else {
                value = _baseToNumber_js_1.default(value);
                other = _baseToNumber_js_1.default(other);
            }
            result = operator(value, other);
        }
        return result;
    };
}
exports.default = createMathOperation;
