"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _apply_js_1 = require("./_apply.js");
var _createCtor_js_1 = require("./_createCtor.js");
var _root_js_1 = require("./_root.js");
var WRAP_BIND_FLAG = 1;
function createPartial(func, bitmask, thisArg, partials) {
    var isBind = bitmask & WRAP_BIND_FLAG, Ctor = _createCtor_js_1.default(func);
    function wrapper() {
        var argsIndex = -1, argsLength = arguments.length, leftIndex = -1, leftLength = partials.length, args = Array(leftLength + argsLength), fn = (this && this !== _root_js_1.default && this instanceof wrapper) ? Ctor : func;
        while (++leftIndex < leftLength) {
            args[leftIndex] = partials[leftIndex];
        }
        while (argsLength--) {
            args[leftIndex++] = arguments[++argsIndex];
        }
        return _apply_js_1.default(fn, isBind ? thisArg : this, args);
    }
    return wrapper;
}
exports.default = createPartial;
