"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _baseRange_js_1 = require("./_baseRange.js");
var _isIterateeCall_js_1 = require("./_isIterateeCall.js");
var toFinite_js_1 = require("./toFinite.js");
function createRange(fromRight) {
    return function (start, end, step) {
        if (step && typeof step != 'number' && _isIterateeCall_js_1.default(start, end, step)) {
            end = step = undefined;
        }
        start = toFinite_js_1.default(start);
        if (end === undefined) {
            end = start;
            start = 0;
        }
        else {
            end = toFinite_js_1.default(end);
        }
        step = step === undefined ? (start < end ? 1 : -1) : toFinite_js_1.default(step);
        return _baseRange_js_1.default(start, end, step, fromRight);
    };
}
exports.default = createRange;
