"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var toInteger_js_1 = require("./toInteger.js");
var toNumber_js_1 = require("./toNumber.js");
var toString_js_1 = require("./toString.js");
var nativeMin = Math.min;
function createRound(methodName) {
    var func = Math[methodName];
    return function (number, precision) {
        number = toNumber_js_1.default(number);
        precision = precision == null ? 0 : nativeMin(toInteger_js_1.default(precision), 292);
        if (precision) {
            var pair = (toString_js_1.default(number) + 'e').split('e'), value = func(pair[0] + 'e' + (+pair[1] + precision));
            pair = (toString_js_1.default(value) + 'e').split('e');
            return +(pair[0] + 'e' + (+pair[1] - precision));
        }
        return func(number);
    };
}
exports.default = createRound;
