"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _DataView_js_1 = require("./_DataView.js");
var _Map_js_1 = require("./_Map.js");
var _Promise_js_1 = require("./_Promise.js");
var _Set_js_1 = require("./_Set.js");
var _WeakMap_js_1 = require("./_WeakMap.js");
var _baseGetTag_js_1 = require("./_baseGetTag.js");
var _toSource_js_1 = require("./_toSource.js");
var mapTag = '[object Map]', objectTag = '[object Object]', promiseTag = '[object Promise]', setTag = '[object Set]', weakMapTag = '[object WeakMap]';
var dataViewTag = '[object DataView]';
var dataViewCtorString = _toSource_js_1.default(_DataView_js_1.default), mapCtorString = _toSource_js_1.default(_Map_js_1.default), promiseCtorString = _toSource_js_1.default(_Promise_js_1.default), setCtorString = _toSource_js_1.default(_Set_js_1.default), weakMapCtorString = _toSource_js_1.default(_WeakMap_js_1.default);
var getTag = _baseGetTag_js_1.default;
if ((_DataView_js_1.default && getTag(new _DataView_js_1.default(new ArrayBuffer(1))) != dataViewTag) ||
    (_Map_js_1.default && getTag(new _Map_js_1.default) != mapTag) ||
    (_Promise_js_1.default && getTag(_Promise_js_1.default.resolve()) != promiseTag) ||
    (_Set_js_1.default && getTag(new _Set_js_1.default) != setTag) ||
    (_WeakMap_js_1.default && getTag(new _WeakMap_js_1.default) != weakMapTag)) {
    getTag = function (value) {
        var result = _baseGetTag_js_1.default(value), Ctor = result == objectTag ? value.constructor : undefined, ctorString = Ctor ? _toSource_js_1.default(Ctor) : '';
        if (ctorString) {
            switch (ctorString) {
                case dataViewCtorString: return dataViewTag;
                case mapCtorString: return mapTag;
                case promiseCtorString: return promiseTag;
                case setCtorString: return setTag;
                case weakMapCtorString: return weakMapTag;
            }
        }
        return result;
    };
}
exports.default = getTag;
