"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _castPath_js_1 = require("./_castPath.js");
var isArguments_js_1 = require("./isArguments.js");
var isArray_js_1 = require("./isArray.js");
var _isIndex_js_1 = require("./_isIndex.js");
var isLength_js_1 = require("./isLength.js");
var _toKey_js_1 = require("./_toKey.js");
function hasPath(object, path, hasFunc) {
    path = _castPath_js_1.default(path, object);
    var index = -1, length = path.length, result = false;
    while (++index < length) {
        var key = _toKey_js_1.default(path[index]);
        if (!(result = object != null && hasFunc(object, key))) {
            break;
        }
        object = object[key];
    }
    if (result || ++index != length) {
        return result;
    }
    length = object == null ? 0 : object.length;
    return !!length && isLength_js_1.default(length) && _isIndex_js_1.default(key, length) &&
        (isArray_js_1.default(object) || isArguments_js_1.default(object));
}
exports.default = hasPath;
