"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _cloneArrayBuffer_js_1 = require("./_cloneArrayBuffer.js");
var _cloneDataView_js_1 = require("./_cloneDataView.js");
var _cloneMap_js_1 = require("./_cloneMap.js");
var _cloneRegExp_js_1 = require("./_cloneRegExp.js");
var _cloneSet_js_1 = require("./_cloneSet.js");
var _cloneSymbol_js_1 = require("./_cloneSymbol.js");
var _cloneTypedArray_js_1 = require("./_cloneTypedArray.js");
var boolTag = '[object Boolean]', dateTag = '[object Date]', mapTag = '[object Map]', numberTag = '[object Number]', regexpTag = '[object RegExp]', setTag = '[object Set]', stringTag = '[object String]', symbolTag = '[object Symbol]';
var arrayBufferTag = '[object ArrayBuffer]', dataViewTag = '[object DataView]', float32Tag = '[object Float32Array]', float64Tag = '[object Float64Array]', int8Tag = '[object Int8Array]', int16Tag = '[object Int16Array]', int32Tag = '[object Int32Array]', uint8Tag = '[object Uint8Array]', uint8ClampedTag = '[object Uint8ClampedArray]', uint16Tag = '[object Uint16Array]', uint32Tag = '[object Uint32Array]';
function initCloneByTag(object, tag, cloneFunc, isDeep) {
    var Ctor = object.constructor;
    switch (tag) {
        case arrayBufferTag:
            return _cloneArrayBuffer_js_1.default(object);
        case boolTag:
        case dateTag:
            return new Ctor(+object);
        case dataViewTag:
            return _cloneDataView_js_1.default(object, isDeep);
        case float32Tag:
        case float64Tag:
        case int8Tag:
        case int16Tag:
        case int32Tag:
        case uint8Tag:
        case uint8ClampedTag:
        case uint16Tag:
        case uint32Tag:
            return _cloneTypedArray_js_1.default(object, isDeep);
        case mapTag:
            return _cloneMap_js_1.default(object, isDeep, cloneFunc);
        case numberTag:
        case stringTag:
            return new Ctor(object);
        case regexpTag:
            return _cloneRegExp_js_1.default(object);
        case setTag:
            return _cloneSet_js_1.default(object, isDeep, cloneFunc);
        case symbolTag:
            return _cloneSymbol_js_1.default(object);
    }
}
exports.default = initCloneByTag;
