"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _baseWrapperValue_js_1 = require("./_baseWrapperValue.js");
var _getView_js_1 = require("./_getView.js");
var isArray_js_1 = require("./isArray.js");
var LAZY_FILTER_FLAG = 1, LAZY_MAP_FLAG = 2;
var nativeMin = Math.min;
function lazyValue() {
    var array = this.__wrapped__.value(), dir = this.__dir__, isArr = isArray_js_1.default(array), isRight = dir < 0, arrLength = isArr ? array.length : 0, view = _getView_js_1.default(0, arrLength, this.__views__), start = view.start, end = view.end, length = end - start, index = isRight ? end : (start - 1), iteratees = this.__iteratees__, iterLength = iteratees.length, resIndex = 0, takeCount = nativeMin(length, this.__takeCount__);
    if (!isArr || (!isRight && arrLength == length && takeCount == length)) {
        return _baseWrapperValue_js_1.default(array, this.__actions__);
    }
    var result = [];
    outer: while (length-- && resIndex < takeCount) {
        index += dir;
        var iterIndex = -1, value = array[index];
        while (++iterIndex < iterLength) {
            var data = iteratees[iterIndex], iteratee = data.iteratee, type = data.type, computed = iteratee(value);
            if (type == LAZY_MAP_FLAG) {
                value = computed;
            }
            else if (!computed) {
                if (type == LAZY_FILTER_FLAG) {
                    continue outer;
                }
                else {
                    break outer;
                }
            }
        }
        result[resIndex++] = value;
    }
    return result;
}
exports.default = lazyValue;
