"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var toInteger_js_1 = require("./toInteger.js");
var FUNC_ERROR_TEXT = 'Expected a function';
function after(n, func) {
    if (typeof func != 'function') {
        throw new TypeError(FUNC_ERROR_TEXT);
    }
    n = toInteger_js_1.default(n);
    return function () {
        if (--n < 1) {
            return func.apply(this, arguments);
        }
    };
}
exports.default = after;
