"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _assignValue_js_1 = require("./_assignValue.js");
var _copyObject_js_1 = require("./_copyObject.js");
var _createAssigner_js_1 = require("./_createAssigner.js");
var isArrayLike_js_1 = require("./isArrayLike.js");
var _isPrototype_js_1 = require("./_isPrototype.js");
var keys_js_1 = require("./keys.js");
var objectProto = Object.prototype;
var hasOwnProperty = objectProto.hasOwnProperty;
var assign = _createAssigner_js_1.default(function (object, source) {
    if (_isPrototype_js_1.default(source) || isArrayLike_js_1.default(source)) {
        _copyObject_js_1.default(source, keys_js_1.default(source), object);
        return;
    }
    for (var key in source) {
        if (hasOwnProperty.call(source, key)) {
            _assignValue_js_1.default(object, key, source[key]);
        }
    }
});
exports.default = assign;
