"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var toInteger_js_1 = require("./toInteger.js");
var FUNC_ERROR_TEXT = 'Expected a function';
function before(n, func) {
    var result;
    if (typeof func != 'function') {
        throw new TypeError(FUNC_ERROR_TEXT);
    }
    n = toInteger_js_1.default(n);
    return function () {
        if (--n > 0) {
            result = func.apply(this, arguments);
        }
        if (n <= 1) {
            func = undefined;
        }
        return result;
    };
}
exports.default = before;
