"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _baseSlice_js_1 = require("./_baseSlice.js");
var _isIterateeCall_js_1 = require("./_isIterateeCall.js");
var toInteger_js_1 = require("./toInteger.js");
var nativeCeil = Math.ceil, nativeMax = Math.max;
function chunk(array, size, guard) {
    if ((guard ? _isIterateeCall_js_1.default(array, size, guard) : size === undefined)) {
        size = 1;
    }
    else {
        size = nativeMax(toInteger_js_1.default(size), 0);
    }
    var length = array == null ? 0 : array.length;
    if (!length || size < 1) {
        return [];
    }
    var index = 0, resIndex = 0, result = Array(nativeCeil(length / size));
    while (index < length) {
        result[resIndex++] = _baseSlice_js_1.default(array, index, (index += size));
    }
    return result;
}
exports.default = chunk;
