"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _apply_js_1 = require("./_apply.js");
var _arrayMap_js_1 = require("./_arrayMap.js");
var _baseIteratee_js_1 = require("./_baseIteratee.js");
var _baseRest_js_1 = require("./_baseRest.js");
var FUNC_ERROR_TEXT = 'Expected a function';
function cond(pairs) {
    var length = pairs == null ? 0 : pairs.length, toIteratee = _baseIteratee_js_1.default;
    pairs = !length ? [] : _arrayMap_js_1.default(pairs, function (pair) {
        if (typeof pair[1] != 'function') {
            throw new TypeError(FUNC_ERROR_TEXT);
        }
        return [toIteratee(pair[0]), pair[1]];
    });
    return _baseRest_js_1.default(function (args) {
        var index = -1;
        while (++index < length) {
            var pair = pairs[index];
            if (_apply_js_1.default(pair[0], this, args)) {
                return _apply_js_1.default(pair[1], this, args);
            }
        }
    });
}
exports.default = cond;
