"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _baseFindIndex_js_1 = require("./_baseFindIndex.js");
var _baseIteratee_js_1 = require("./_baseIteratee.js");
var toInteger_js_1 = require("./toInteger.js");
var nativeMax = Math.max, nativeMin = Math.min;
function findLastIndex(array, predicate, fromIndex) {
    var length = array == null ? 0 : array.length;
    if (!length) {
        return -1;
    }
    var index = length - 1;
    if (fromIndex !== undefined) {
        index = toInteger_js_1.default(fromIndex);
        index = fromIndex < 0
            ? nativeMax(length + index, 0)
            : nativeMin(index, length - 1);
    }
    return _baseFindIndex_js_1.default(array, _baseIteratee_js_1.default(predicate, 3), index, true);
}
exports.default = findLastIndex;
