"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _baseKeys_js_1 = require("./_baseKeys.js");
var _getTag_js_1 = require("./_getTag.js");
var isArguments_js_1 = require("./isArguments.js");
var isArray_js_1 = require("./isArray.js");
var isArrayLike_js_1 = require("./isArrayLike.js");
var isBuffer_js_1 = require("./isBuffer.js");
var _isPrototype_js_1 = require("./_isPrototype.js");
var isTypedArray_js_1 = require("./isTypedArray.js");
var mapTag = '[object Map]', setTag = '[object Set]';
var objectProto = Object.prototype;
var hasOwnProperty = objectProto.hasOwnProperty;
function isEmpty(value) {
    if (value == null) {
        return true;
    }
    if (isArrayLike_js_1.default(value) &&
        (isArray_js_1.default(value) || typeof value == 'string' || typeof value.splice == 'function' ||
            isBuffer_js_1.default(value) || isTypedArray_js_1.default(value) || isArguments_js_1.default(value))) {
        return !value.length;
    }
    var tag = _getTag_js_1.default(value);
    if (tag == mapTag || tag == setTag) {
        return !value.size;
    }
    if (_isPrototype_js_1.default(value)) {
        return !_baseKeys_js_1.default(value).length;
    }
    for (var key in value) {
        if (hasOwnProperty.call(value, key)) {
            return false;
        }
    }
    return true;
}
exports.default = isEmpty;
