"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _baseGetTag_js_1 = require("./_baseGetTag.js");
var _getPrototype_js_1 = require("./_getPrototype.js");
var isObjectLike_js_1 = require("./isObjectLike.js");
var objectTag = '[object Object]';
var funcProto = Function.prototype, objectProto = Object.prototype;
var funcToString = funcProto.toString;
var hasOwnProperty = objectProto.hasOwnProperty;
var objectCtorString = funcToString.call(Object);
function isPlainObject(value) {
    if (!isObjectLike_js_1.default(value) || _baseGetTag_js_1.default(value) != objectTag) {
        return false;
    }
    var proto = _getPrototype_js_1.default(value);
    if (proto === null) {
        return true;
    }
    var Ctor = hasOwnProperty.call(proto, 'constructor') && proto.constructor;
    return typeof Ctor == 'function' && Ctor instanceof Ctor &&
        funcToString.call(Ctor) == objectCtorString;
}
exports.default = isPlainObject;
