"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _baseFindIndex_js_1 = require("./_baseFindIndex.js");
var _baseIsNaN_js_1 = require("./_baseIsNaN.js");
var _strictLastIndexOf_js_1 = require("./_strictLastIndexOf.js");
var toInteger_js_1 = require("./toInteger.js");
var nativeMax = Math.max, nativeMin = Math.min;
function lastIndexOf(array, value, fromIndex) {
    var length = array == null ? 0 : array.length;
    if (!length) {
        return -1;
    }
    var index = length;
    if (fromIndex !== undefined) {
        index = toInteger_js_1.default(fromIndex);
        index = index < 0 ? nativeMax(length + index, 0) : nativeMin(index, length - 1);
    }
    return value === value
        ? _strictLastIndexOf_js_1.default(array, value, index)
        : _baseFindIndex_js_1.default(array, _baseIsNaN_js_1.default, index, true);
}
exports.default = lastIndexOf;
