"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _arrayEach_js_1 = require("./_arrayEach.js");
var _arrayPush_js_1 = require("./_arrayPush.js");
var _baseFunctions_js_1 = require("./_baseFunctions.js");
var _copyArray_js_1 = require("./_copyArray.js");
var isFunction_js_1 = require("./isFunction.js");
var isObject_js_1 = require("./isObject.js");
var keys_js_1 = require("./keys.js");
function mixin(object, source, options) {
    var props = keys_js_1.default(source), methodNames = _baseFunctions_js_1.default(source, props);
    var chain = !(isObject_js_1.default(options) && 'chain' in options) || !!options.chain, isFunc = isFunction_js_1.default(object);
    _arrayEach_js_1.default(methodNames, function (methodName) {
        var func = source[methodName];
        object[methodName] = func;
        if (isFunc) {
            object.prototype[methodName] = function () {
                var chainAll = this.__chain__;
                if (chain || chainAll) {
                    var result = object(this.__wrapped__), actions = result.__actions__ = _copyArray_js_1.default(this.__actions__);
                    actions.push({ 'func': func, 'args': arguments, 'thisArg': object });
                    result.__chain__ = chainAll;
                    return result;
                }
                return func.apply(object, _arrayPush_js_1.default([this.value()], arguments));
            };
        }
    });
    return object;
}
exports.default = mixin;
