"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _arrayMap_js_1 = require("./_arrayMap.js");
var _baseClone_js_1 = require("./_baseClone.js");
var _baseUnset_js_1 = require("./_baseUnset.js");
var _castPath_js_1 = require("./_castPath.js");
var _copyObject_js_1 = require("./_copyObject.js");
var _customOmitClone_js_1 = require("./_customOmitClone.js");
var _flatRest_js_1 = require("./_flatRest.js");
var _getAllKeysIn_js_1 = require("./_getAllKeysIn.js");
var CLONE_DEEP_FLAG = 1, CLONE_FLAT_FLAG = 2, CLONE_SYMBOLS_FLAG = 4;
var omit = _flatRest_js_1.default(function (object, paths) {
    var result = {};
    if (object == null) {
        return result;
    }
    var isDeep = false;
    paths = _arrayMap_js_1.default(paths, function (path) {
        path = _castPath_js_1.default(path, object);
        isDeep || (isDeep = path.length > 1);
        return path;
    });
    _copyObject_js_1.default(object, _getAllKeysIn_js_1.default(object), result);
    if (isDeep) {
        result = _baseClone_js_1.default(result, CLONE_DEEP_FLAG | CLONE_FLAT_FLAG | CLONE_SYMBOLS_FLAG, _customOmitClone_js_1.default);
    }
    var length = paths.length;
    while (length--) {
        _baseUnset_js_1.default(result, paths[length]);
    }
    return result;
});
exports.default = omit;
