"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _apply_js_1 = require("./_apply.js");
var _arrayMap_js_1 = require("./_arrayMap.js");
var _baseFlatten_js_1 = require("./_baseFlatten.js");
var _baseIteratee_js_1 = require("./_baseIteratee.js");
var _baseRest_js_1 = require("./_baseRest.js");
var _baseUnary_js_1 = require("./_baseUnary.js");
var _castRest_js_1 = require("./_castRest.js");
var isArray_js_1 = require("./isArray.js");
var nativeMin = Math.min;
var overArgs = _castRest_js_1.default(function (func, transforms) {
    transforms = (transforms.length == 1 && isArray_js_1.default(transforms[0]))
        ? _arrayMap_js_1.default(transforms[0], _baseUnary_js_1.default(_baseIteratee_js_1.default))
        : _arrayMap_js_1.default(_baseFlatten_js_1.default(transforms, 1), _baseUnary_js_1.default(_baseIteratee_js_1.default));
    var funcsLength = transforms.length;
    return _baseRest_js_1.default(function (args) {
        var index = -1, length = nativeMin(args.length, funcsLength);
        while (++index < length) {
            args[index] = transforms[index].call(this, args[index]);
        }
        return _apply_js_1.default(func, this, args);
    });
});
exports.default = overArgs;
