"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _createPadding_js_1 = require("./_createPadding.js");
var _stringSize_js_1 = require("./_stringSize.js");
var toInteger_js_1 = require("./toInteger.js");
var toString_js_1 = require("./toString.js");
var nativeCeil = Math.ceil, nativeFloor = Math.floor;
function pad(string, length, chars) {
    string = toString_js_1.default(string);
    length = toInteger_js_1.default(length);
    var strLength = length ? _stringSize_js_1.default(string) : 0;
    if (!length || strLength >= length) {
        return string;
    }
    var mid = (length - strLength) / 2;
    return (_createPadding_js_1.default(nativeFloor(mid), chars) +
        string +
        _createPadding_js_1.default(nativeCeil(mid), chars));
}
exports.default = pad;
