"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _baseRandom_js_1 = require("./_baseRandom.js");
var _isIterateeCall_js_1 = require("./_isIterateeCall.js");
var toFinite_js_1 = require("./toFinite.js");
var freeParseFloat = parseFloat;
var nativeMin = Math.min, nativeRandom = Math.random;
function random(lower, upper, floating) {
    if (floating && typeof floating != 'boolean' && _isIterateeCall_js_1.default(lower, upper, floating)) {
        upper = floating = undefined;
    }
    if (floating === undefined) {
        if (typeof upper == 'boolean') {
            floating = upper;
            upper = undefined;
        }
        else if (typeof lower == 'boolean') {
            floating = lower;
            lower = undefined;
        }
    }
    if (lower === undefined && upper === undefined) {
        lower = 0;
        upper = 1;
    }
    else {
        lower = toFinite_js_1.default(lower);
        if (upper === undefined) {
            upper = lower;
            lower = 0;
        }
        else {
            upper = toFinite_js_1.default(upper);
        }
    }
    if (lower > upper) {
        var temp = lower;
        lower = upper;
        upper = temp;
    }
    if (floating || lower % 1 || upper % 1) {
        var rand = nativeRandom();
        return nativeMin(lower + (rand * (upper - lower + freeParseFloat('1e-' + ((rand + '').length - 1)))), upper);
    }
    return _baseRandom_js_1.default(lower, upper);
}
exports.default = random;
