"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _castPath_js_1 = require("./_castPath.js");
var isFunction_js_1 = require("./isFunction.js");
var _toKey_js_1 = require("./_toKey.js");
function result(object, path, defaultValue) {
    path = _castPath_js_1.default(path, object);
    var index = -1, length = path.length;
    if (!length) {
        length = 1;
        object = undefined;
    }
    while (++index < length) {
        var value = object == null ? undefined : object[_toKey_js_1.default(path[index])];
        if (value === undefined) {
            index = length;
            value = defaultValue;
        }
        object = isFunction_js_1.default(value) ? value.call(object) : value;
    }
    return object;
}
exports.default = result;
