"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _baseKeys_js_1 = require("./_baseKeys.js");
var _getTag_js_1 = require("./_getTag.js");
var isArrayLike_js_1 = require("./isArrayLike.js");
var isString_js_1 = require("./isString.js");
var _stringSize_js_1 = require("./_stringSize.js");
var mapTag = '[object Map]', setTag = '[object Set]';
function size(collection) {
    if (collection == null) {
        return 0;
    }
    if (isArrayLike_js_1.default(collection)) {
        return isString_js_1.default(collection) ? _stringSize_js_1.default(collection) : collection.length;
    }
    var tag = _getTag_js_1.default(collection);
    if (tag == mapTag || tag == setTag) {
        return collection.size;
    }
    return _baseKeys_js_1.default(collection).length;
}
exports.default = size;
