"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _baseToString_js_1 = require("./_baseToString.js");
var _castSlice_js_1 = require("./_castSlice.js");
var _hasUnicode_js_1 = require("./_hasUnicode.js");
var _isIterateeCall_js_1 = require("./_isIterateeCall.js");
var isRegExp_js_1 = require("./isRegExp.js");
var _stringToArray_js_1 = require("./_stringToArray.js");
var toString_js_1 = require("./toString.js");
var MAX_ARRAY_LENGTH = 4294967295;
function split(string, separator, limit) {
    if (limit && typeof limit != 'number' && _isIterateeCall_js_1.default(string, separator, limit)) {
        separator = limit = undefined;
    }
    limit = limit === undefined ? MAX_ARRAY_LENGTH : limit >>> 0;
    if (!limit) {
        return [];
    }
    string = toString_js_1.default(string);
    if (string && (typeof separator == 'string' ||
        (separator != null && !isRegExp_js_1.default(separator)))) {
        separator = _baseToString_js_1.default(separator);
        if (!separator && _hasUnicode_js_1.default(string)) {
            return _castSlice_js_1.default(_stringToArray_js_1.default(string), 0, limit);
        }
    }
    return string.split(separator, limit);
}
exports.default = split;
