"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _apply_js_1 = require("./_apply.js");
var _arrayPush_js_1 = require("./_arrayPush.js");
var _baseRest_js_1 = require("./_baseRest.js");
var _castSlice_js_1 = require("./_castSlice.js");
var toInteger_js_1 = require("./toInteger.js");
var FUNC_ERROR_TEXT = 'Expected a function';
var nativeMax = Math.max;
function spread(func, start) {
    if (typeof func != 'function') {
        throw new TypeError(FUNC_ERROR_TEXT);
    }
    start = start == null ? 0 : nativeMax(toInteger_js_1.default(start), 0);
    return _baseRest_js_1.default(function (args) {
        var array = args[start], otherArgs = _castSlice_js_1.default(args, 0, start);
        if (array) {
            _arrayPush_js_1.default(otherArgs, array);
        }
        return _apply_js_1.default(func, this, otherArgs);
    });
}
exports.default = spread;
