"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var debounce_js_1 = require("./debounce.js");
var isObject_js_1 = require("./isObject.js");
var FUNC_ERROR_TEXT = 'Expected a function';
function throttle(func, wait, options) {
    var leading = true, trailing = true;
    if (typeof func != 'function') {
        throw new TypeError(FUNC_ERROR_TEXT);
    }
    if (isObject_js_1.default(options)) {
        leading = 'leading' in options ? !!options.leading : leading;
        trailing = 'trailing' in options ? !!options.trailing : trailing;
    }
    return debounce_js_1.default(func, wait, {
        'leading': leading,
        'maxWait': wait,
        'trailing': trailing
    });
}
exports.default = throttle;
