"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _baseTimes_js_1 = require("./_baseTimes.js");
var _castFunction_js_1 = require("./_castFunction.js");
var toInteger_js_1 = require("./toInteger.js");
var MAX_SAFE_INTEGER = 9007199254740991;
var MAX_ARRAY_LENGTH = 4294967295;
var nativeMin = Math.min;
function times(n, iteratee) {
    n = toInteger_js_1.default(n);
    if (n < 1 || n > MAX_SAFE_INTEGER) {
        return [];
    }
    var index = MAX_ARRAY_LENGTH, length = nativeMin(n, MAX_ARRAY_LENGTH);
    iteratee = _castFunction_js_1.default(iteratee);
    n -= MAX_ARRAY_LENGTH;
    var result = _baseTimes_js_1.default(length, iteratee);
    while (++index < n) {
        iteratee(index);
    }
    return result;
}
exports.default = times;
