"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _Symbol_js_1 = require("./_Symbol.js");
var _copyArray_js_1 = require("./_copyArray.js");
var _getTag_js_1 = require("./_getTag.js");
var isArrayLike_js_1 = require("./isArrayLike.js");
var isString_js_1 = require("./isString.js");
var _iteratorToArray_js_1 = require("./_iteratorToArray.js");
var _mapToArray_js_1 = require("./_mapToArray.js");
var _setToArray_js_1 = require("./_setToArray.js");
var _stringToArray_js_1 = require("./_stringToArray.js");
var values_js_1 = require("./values.js");
var mapTag = '[object Map]', setTag = '[object Set]';
var symIterator = _Symbol_js_1.default ? _Symbol_js_1.default.iterator : undefined;
function toArray(value) {
    if (!value) {
        return [];
    }
    if (isArrayLike_js_1.default(value)) {
        return isString_js_1.default(value) ? _stringToArray_js_1.default(value) : _copyArray_js_1.default(value);
    }
    if (symIterator && value[symIterator]) {
        return _iteratorToArray_js_1.default(value[symIterator]());
    }
    var tag = _getTag_js_1.default(value), func = tag == mapTag ? _mapToArray_js_1.default : (tag == setTag ? _setToArray_js_1.default : values_js_1.default);
    return func(value);
}
exports.default = toArray;
