"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var isObject_js_1 = require("./isObject.js");
var isSymbol_js_1 = require("./isSymbol.js");
var NAN = 0 / 0;
var reTrim = /^\s+|\s+$/g;
var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;
var reIsBinary = /^0b[01]+$/i;
var reIsOctal = /^0o[0-7]+$/i;
var freeParseInt = parseInt;
function toNumber(value) {
    if (typeof value == 'number') {
        return value;
    }
    if (isSymbol_js_1.default(value)) {
        return NAN;
    }
    if (isObject_js_1.default(value)) {
        var other = typeof value.valueOf == 'function' ? value.valueOf() : value;
        value = isObject_js_1.default(other) ? (other + '') : other;
    }
    if (typeof value != 'string') {
        return value === 0 ? value : +value;
    }
    value = value.replace(reTrim, '');
    var isBinary = reIsBinary.test(value);
    return (isBinary || reIsOctal.test(value))
        ? freeParseInt(value.slice(2), isBinary ? 2 : 8)
        : (reIsBadHex.test(value) ? NAN : +value);
}
exports.default = toNumber;
