"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _arrayEach_js_1 = require("./_arrayEach.js");
var _baseCreate_js_1 = require("./_baseCreate.js");
var _baseForOwn_js_1 = require("./_baseForOwn.js");
var _baseIteratee_js_1 = require("./_baseIteratee.js");
var _getPrototype_js_1 = require("./_getPrototype.js");
var isArray_js_1 = require("./isArray.js");
var isBuffer_js_1 = require("./isBuffer.js");
var isFunction_js_1 = require("./isFunction.js");
var isObject_js_1 = require("./isObject.js");
var isTypedArray_js_1 = require("./isTypedArray.js");
function transform(object, iteratee, accumulator) {
    var isArr = isArray_js_1.default(object), isArrLike = isArr || isBuffer_js_1.default(object) || isTypedArray_js_1.default(object);
    iteratee = _baseIteratee_js_1.default(iteratee, 4);
    if (accumulator == null) {
        var Ctor = object && object.constructor;
        if (isArrLike) {
            accumulator = isArr ? new Ctor : [];
        }
        else if (isObject_js_1.default(object)) {
            accumulator = isFunction_js_1.default(Ctor) ? _baseCreate_js_1.default(_getPrototype_js_1.default(object)) : {};
        }
        else {
            accumulator = {};
        }
    }
    (isArrLike ? _arrayEach_js_1.default : _baseForOwn_js_1.default)(object, function (value, index, object) {
        return iteratee(accumulator, value, index, object);
    });
    return accumulator;
}
exports.default = transform;
