"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _baseToString_js_1 = require("./_baseToString.js");
var _castSlice_js_1 = require("./_castSlice.js");
var _charsEndIndex_js_1 = require("./_charsEndIndex.js");
var _charsStartIndex_js_1 = require("./_charsStartIndex.js");
var _stringToArray_js_1 = require("./_stringToArray.js");
var toString_js_1 = require("./toString.js");
var reTrim = /^\s+|\s+$/g;
function trim(string, chars, guard) {
    string = toString_js_1.default(string);
    if (string && (guard || chars === undefined)) {
        return string.replace(reTrim, '');
    }
    if (!string || !(chars = _baseToString_js_1.default(chars))) {
        return string;
    }
    var strSymbols = _stringToArray_js_1.default(string), chrSymbols = _stringToArray_js_1.default(chars), start = _charsStartIndex_js_1.default(strSymbols, chrSymbols), end = _charsEndIndex_js_1.default(strSymbols, chrSymbols) + 1;
    return _castSlice_js_1.default(strSymbols, start, end).join('');
}
exports.default = trim;
